#include <FastLED.h>

struct Color{
 int r,g,b;
};
float brightness = 0.1;
CRGB leds[NUM_LEDS];

unsigned long lastTimeLED;
int indexLed;

Color HSVtoRGB(float H, float S,float V);

void setupLED() {
  pinMode(LED_PIN, OUTPUT);
  FastLED.addLeds<WS2812, LED_PIN, GRB>(leds, NUM_LEDS);

}

void loopLED() {

  if(millis()-lastTimeLED > 30)//every 30ms change a led color
  {
    UpdateStrip();
    lastTimeLED = millis();
  }
  
}

void UpdateStrip()
{
  indexLed++; //next led
  //leds[0] = CRGB(255,0,0);
  if(millis()-lastScoreTime < 4000) // get score in 4 second, rgb effect
  {
    Color c;
    c = HSVtoRGB((millis()/10)%360,100,100);
    leds[indexLed%NUM_LEDS] = CRGB (c.r *brightness, c.g*brightness, c.b*brightness);
  }
  else //default random color
  {
      if(indexLed%(NUM_LEDS*2) - NUM_LEDS >= 0)//total 0-59, if 30-59, set led off
      {
        leds[indexLed%NUM_LEDS]= CRGB (0,0,0);
      }
      else //0-29, set led on
      {
        leds[indexLed%NUM_LEDS] = CRGB (Random_0_255()*brightness , Random_0_255()*brightness, Random_0_255()*brightness);
      }
  }
  
  FastLED.show();
  
}

Color HSVtoRGB(float H, float S,float V){
  Color c;
  if(H>360 || H<0 || S>100 || S<0 || V>100 || V<0){
    return c;
  }
  float s = S/100;
  float v = V/100;
  float C = s*v;
  float X = C*(1-abs(fmod(H/60.0, 2)-1));
  float m = v-C;
  float r,g,b;
  if(H >= 0 && H < 60){
      r = C,g = X,b = 0;
  }
  else if(H >= 60 && H < 120){
      r = X,g = C,b = 0;
  }
  else if(H >= 120 && H < 180){
      r = 0,g = C,b = X;
  }
  else if(H >= 180 && H < 240){
      r = 0,g = X,b = C;
  }
  else if(H >= 240 && H < 300){
      r = X,g = 0,b = C;
  }
  else{
      r = C,g = 0,b = X;
  }
  int R = (r+m)*255;
  int G = (g+m)*255;
  int B = (b+m)*255;

  c.r = R;
  c.g = G;
  c.b = B;
  return c;
}

float Random_0_255()
{
  return rand() % 256;
}